unit frmServer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
  , IdTCPServer // PeerThread
  , XMLWorksRPC, StdCtrls;

type
  TForm2 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    RPCServer : TXMLRPCServer;
    procedure ServerRequest(AThread: TIdPeerThread; const RemoteIP,
      RequestInfo: String; var ResponseInfo: String);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation


{$R *.DFM}

procedure TForm2.ServerRequest(AThread: TIdPeerThread; const RemoteIP:
          String; const RequestInfo: String; var ResponseInfo: String);
var
  Response: TXMLRPCMethodResponseBase;
begin
  Response := nil;
  try
    Memo1.Lines.Text := RequestInfo;
{    if RequestInfo.RPCmethodName = 'sum' then
    begin
      Response := TXMLRPCMethodResponseParams.Create;
      Response.params.param.AddInteger(100);
    end
    else
    begin}
      Response := TXMLRPCMethodResponseFault.Create;
      Response.fault.AddInteger(4).Name := 'faultCode';
      Response.fault.AddString('Invalid Request').Name := 'faultString';
//    end;

    ResponseInfo := Response.XML;
  finally
    Response.Free;
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  RPCServer := TXMLRPCServer.Create(6060);
  RPCServer.OnRequest := ServerREquest;
  RPCServer.Active := True;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  RPCServer.Free;
end;

end.
